digiKam Developer Documentation: Digikam::TagCheckView Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Types | Public Slots | Signals | Public Member Functions | Protected Member Functions | List of all members
Digikam::TagCheckView Class Reference
Inheritance diagram for Digikam::TagCheckView:

## Public Types
enum | ToggleAutoTags { NoToggleAuto = 0 , Children , Parents , ChildrenAndParents }
Public Types inherited from Digikam::AbstractAlbumTreeView
enum | Flag { CreateDefaultModel , CreateDefaultFilterModel , CreateDefaultDelegate , ShowCountAccordingToSettings , AlwaysShowInclusiveCounts , DefaultFlags = CreateDefaultFilterModel | CreateDefaultDelegate | ShowCountAccordingToSettings }
typedef QFlags< Flag > | Flags
Public Types inherited from Digikam::StateSavingObject
enum | StateSavingDepth { INSTANCE , DIRECT_CHILDREN , RECURSIVE }
| This enum defines the "depth" of the StateSavingObject::loadState() and StateSavingObject::saveState() methods. More...

## Public Slots
void | slotResetCheckState ()
| Resets the whole tag filter.
Public Slots inherited from Digikam::TagFolderView
void | slotTagNewFromABCMenu (const QString &personName)
Public Slots inherited from Digikam::TagTreeView
void | setCurrentAlbum (int tagId, bool selectInAlbumManager=true)
Public Slots inherited from Digikam::AbstractAlbumTreeView
void | adaptColumnsToContent ()
| Adapt the column sizes to the contents of the tree view.
void | expandEverything (const QModelIndex &index)
| Expands the complete tree under the given index.
void | scrollToSelectedAlbum ()
| Scrolls to the first selected album if there is one.
void | setCurrentAlbums (const QList< Album * > &albums, bool selectInAlbumManager=true)
| Selects the given album.
void | setSearchTextSettings (const SearchTextSettings &settings)
void | slotCollapseAllNodes ()
| slotCollapseAllNodes - collapse all nodes without root node
void | slotCollapseNode ()
| slotCollapseNode - collapse recursively selected nodes
void | slotExpandNode ()
| slotExpandNode - expands recursively selected nodes

## Signals
void | checkedTagsChanged (const QList< TAlbum * > &includedTags, const QList< TAlbum * > &excludedTags)
| Emitted if the checked tags have changed.
Signals inherited from Digikam::TagFolderView
void | signalFindDuplicates (const QList< TAlbum * > &albums)
Signals inherited from Digikam::TagTreeView
void | assignTags (int tagId, const QList< int > &imageIDs)
Signals inherited from Digikam::AbstractAlbumTreeView
void | currentAlbumChanged (Album *currentAlbum)
| Emitted when the currently selected album changes.
void | selectedAlbumsChanged (const QList< Album * > &selectedAlbums)
| Emitted when the current selection changes.

## Public Member Functions
| TagCheckView (QWidget *const parent, TagModel *const tagModel)
bool | checkNewTags () const
void | doLoadState () override
| Implements state loading for the album tree view in a somewhat clumsy procedure because the model may not be fully loaded when this method is called.
void | doSaveState () override
| Implement this hook method for state saving.
QList< TAlbum * > | getCheckedTags () const
QList< TAlbum * > | getPartiallyCheckedTags () const
ToggleAutoTags | getToggleAutoTags () const
void | setCheckNewTags (bool checkNewTags)
| If.
void | setToggleAutoTags (ToggleAutoTags toggle)
Public Member Functions inherited from Digikam::TagFolderView
| TagFolderView (QWidget *const parent, TagModel *const model)
| Constructor.
| ~TagFolderView () override
| Destructor.
void | setShowDeleteFaceTagsAction (bool show)
| Define whether to show the "Delete People Tags" action in context menus or not.
void | setShowFindDuplicateAction (bool show)
| Define whether to show the "find duplicate" action in context menus or not.
void | tagPropsEdit ()
| Open tag for editing.
Public Member Functions inherited from Digikam::TagTreeView
| TagTreeView (QWidget *const parent=nullptr, Flags flags=DefaultFlags)
TAlbum * | albumForIndex (const QModelIndex &index) const
TAlbum * | currentAlbum () const
| currentAlbum Even if multiple selection is enabled current Album can be only one, the last clicked item if you need selected items, see selectedAlbums() It's NOT the same as AlbumManager::currentAlbums()
TagPropertiesFilterModel * | filteredModel () const
| Contains only the tags filtered by properties - prefer to albumModel()
QList< TAlbum * > | selectedTagAlbums ()
QList< Album * > | selectedTags ()
| selectedTags - return a list of all selected items in tag model
void | setTAlbumFilterModel (TagPropertiesFilterModel *const filteredModel, CheckableAlbumFilterModel *const filterModel)
void | setTAlbumModel (TagModel *const model)
TagModificationHelper * | tagModificationHelper () const
TagModel * | talbumModel () const
Public Member Functions inherited from Digikam::AbstractCheckableAlbumTreeView
| AbstractCheckableAlbumTreeView (QWidget *const parent, Flags flags)
CheckableAlbumFilterModel * | checkableAlbumFilterModel () const
AbstractCheckableAlbumModel * | checkableAlbumModel () const
| Manage check state through the model directly.
bool | isRestoreCheckState () const
| Tells if the check state is restored while loading / saving state.
void | setCheckOnMiddleClick (bool doThat)
| Enable checking on middle mouse button click (default: on).
void | setRestoreCheckState (bool restore)
| Set whether to restore check state or not.
Public Member Functions inherited from Digikam::AbstractCountingAlbumTreeView
| AbstractCountingAlbumTreeView (QWidget *const parent, Flags flags)
Public Member Functions inherited from Digikam::AbstractAlbumTreeView
| AbstractAlbumTreeView (QWidget *const parent, Flags flags)
| Constructs an album tree view.
void | addContextMenuElement (ContextMenuElement *const element)
AlbumFilterModel * | albumFilterModel () const
AbstractSpecificAlbumModel * | albumModel () const
QList< ContextMenuElement * > | contextMenuElements () const
template<class A >
QList< A * > | currentAlbums ()
bool | expandMatches (const QModelIndex &index)
| Ensures that every current match is visible by expanding all parent entries.
QModelIndex | indexVisuallyAt (const QPoint &p)
| This is a combination of indexAt() checked with visualRect().
void | removeContextMenuElement (ContextMenuElement *const element)
QList< Album * > | selectedItems ()
void | setAlbumManagerCurrentAlbum (const bool setCurrentAlbum)
| Some treeviews shall control the global current album kept by AlbumManager.
void | setContextMenuIcon (const QPixmap &pixmap)
| Set the context menu title and icon.
void | setContextMenuTitle (const QString &title)
void | setEnableContextMenu (const bool enable)
| Determines the global decision to show a popup menu or not.
void | setExpandNewCurrentItem (const bool doThat)
| Expand an item when making it the new current item.
void | setExpandOnSingleClick (const bool doThat)
| Enable expanding of tree items on single click on the item (default: off)
void | setSelectAlbumOnClick (const bool selectOnClick)
| Sets whether to select an album on click via the album manager or not.
void | setSelectOnContextMenu (const bool select)
| Sets whether to select the album under the mouse cursor on a context menu request (so that the album is shown using the album manager) or not.
bool | viewportEvent (QEvent *event) override
| For internal use only.
Public Member Functions inherited from Digikam::StateSavingObject
| StateSavingObject (QObject *const host)
| Constructor.
virtual | ~StateSavingObject ()
| Destructor.
StateSavingDepth | getStateSavingDepth () const
| Returns the depth used for state saving or loading.
void | loadState ()
| Invokes loading the class' state.
void | saveState ()
| Invokes saving the class' state.
virtual void | setConfigGroup (const KConfigGroup &group)
| Sets a dedicated config group that will be used to store and reload the state from.
virtual void | setEntryPrefix (const QString &prefix)
| Define a prefix that will be used for every entry in the config group.
void | setStateSavingDepth (const StateSavingDepth depth)
| Sets the depth used for state saving or loading.

## Protected Member Functions
void | addCustomContextMenuActions (ContextMenuHelper &cmh, Album *album) override
| Hook method to add custom actions to the generated context menu.
Protected Member Functions inherited from Digikam::TagFolderView
void | addCustomContextMenuActions (ContextMenuHelper &cmh, Album *album) override
| Hook method to add custom actions to the generated context menu.
void | contextMenuEvent (QContextMenuEvent *event) override
| Reimplement contextMenuEvent from AbstractAlbumTree to support multiple selection.
QString | contextMenuTitle () const override
| Hook method to implement that returns the title for the context menu.
void | handleCustomContextMenuAction (QAction *action, const AlbumPointer< Album > &album) override
| Hook method to handle the custom context menu actions that were added with addCustomContextMenuActions.
void | keyPressEvent (QKeyEvent *event) override
virtual void | setContexMenuItems (ContextMenuHelper &cmh, const QList< TAlbum * > &albums)
| Implementation of AddCustomContextMenuActions(see above) that handle multiple selection.
Protected Member Functions inherited from Digikam::AbstractCheckableAlbumTreeView
void | middleButtonPressed (Album *a) override
void | rowsInserted (const QModelIndex &parent, int start, int end) override
void | setAlbumModel (AbstractCheckableAlbumModel *const model)
virtual void | setCheckableAlbumFilterModel (CheckableAlbumFilterModel *const filterModel)
Protected Member Functions inherited from Digikam::AbstractCountingAlbumTreeView
void | rowsInserted (const QModelIndex &parent, int start, int end) override
virtual void | setAlbumFilterModel (AlbumFilterModel *const filterModel) override
void | setAlbumModel (AbstractCountingAlbumModel *const model)
Protected Member Functions inherited from Digikam::AbstractAlbumTreeView
virtual QPixmap | contextMenuIcon () const
| Hook method that can be implemented to return a special icon used for the context menu.
void | dragEnterEvent (QDragEnterEvent *e) override
void | dragLeaveEvent (QDragLeaveEvent *e) override
void | dragMoveEvent (QDragMoveEvent *e) override
void | dropEvent (QDropEvent *e) override
void | mousePressEvent (QMouseEvent *e) override
| Other helper methods.
virtual QPixmap | pixmapForDrag (const QStyleOptionViewItem &option, QList< QModelIndex > indexes)
void | rowsAboutToBeRemoved (const QModelIndex &parent, int start, int end) override
void | rowsInserted (const QModelIndex &index, int start, int end) override
void | setAlbumModel (AbstractSpecificAlbumModel *const model)
virtual bool | showContextMenuAt (QContextMenuEvent *event, Album *albumForEvent)
| Hook method to implement that determines if a context menu shall be displayed for the given event at the position coded in the event.
void | startDrag (Qt::DropActions supportedActions) override
Protected Member Functions inherited from Digikam::StateSavingObject
QString | entryName (const QString &base) const
| Always use this method to create config group entry names.
KConfigGroup | getConfigGroup () const
| Returns the config group that must be used for state saving and loading.

## Additional Inherited Members
Protected Slots inherited from Digikam::AbstractAlbumTreeView
void | albumSettingsChanged ()
void | slotCurrentChanged ()
virtual void | slotRootAlbumAvailable ()
void | slotSearchTextSettingsAboutToChange (bool searched, bool willSearch)
void | slotSearchTextSettingsChanged (bool wasSearching, bool searching)
void | slotSelectionChanged ()
Protected Attributes inherited from Digikam::TagTreeView
TagPropertiesFilterModel * | m_filteredModel = nullptr
TagModificationHelper * | m_modificationHelper = nullptr
Protected Attributes inherited from Digikam::AbstractAlbumTreeView
AlbumFilterModel * | m_albumFilterModel = nullptr
AbstractSpecificAlbumModel * | m_albumModel = nullptr
bool | m_checkOnMiddleClick = false
AlbumModelDragDropHandler * | m_dragDropHandler = nullptr
Flags | m_flags = DefaultFlags
int | m_lastScrollBarValue = 0
bool | m_restoreCheckState = false

## Member Function Documentation

## ◆ addCustomContextMenuActions()

void Digikam::TagCheckView::addCustomContextMenuActions | ( | ContextMenuHelper & | cmh,
|  | Album * | album
| ) |  |
| overrideprotectedvirtual

Parameters

  cmh | helper object to create the context menu
  album | tag on which the context menu will be created. May be null if it is requested on no tag entry

Reimplemented from Digikam::AbstractAlbumTreeView.

Reimplemented in Digikam::TagFilterView.

## ◆ checkedTagsChanged

void Digikam::TagCheckView::checkedTagsChanged | ( | const QList< TAlbum * > & | includedTags,
|  | const QList< TAlbum * > & | excludedTags
| ) |  |
| signal

Parameters

  includedTags | a list of selected tag ids processed.
  excludedTags | a list of tag ids ignored.

## ◆ doLoadState()

void Digikam::TagCheckView::doLoadState | ( |  | ) |
| overridevirtual

Therefore the config is first parsed into d->statesByAlbumId which holds the state of all tree view entries indexed by album id. Afterwards an initial sync run is done restoring the state of all model entries that are already present at this time. Every processed entry is removed from d->statesByAlbumId. If there are still entries left in this map we assume that the model is not fully loaded at the moment. Therefore the rowsInserted signal is connected to a slot that restores the state of new rows based on the remaining entries in d->statesByAlbumId.

Reimplemented from Digikam::AbstractCheckableAlbumTreeView.

## ◆ doSaveState()

void Digikam::TagCheckView::doSaveState | ( |  | ) |
| overridevirtual

Use getConfigGroup() and entryName() for the implementation.

Reimplemented from Digikam::AbstractCheckableAlbumTreeView.

## ◆ setCheckNewTags()

void Digikam::TagCheckView::setCheckNewTags | ( | bool | checkNewTags | ) |

Parameters

  checkNewTags | is switched on, a tag that is created from within this view, typically via the context menu, will automatically be set checked.